<template>
  <div class="GitlabReposTab _tabcontent">
    <tab-simple
      v-model="items"
      :is-tab-active="isTabActive"
      :item-title="'L: copy path to clipboard, R: open repo url'"
      @leftClick="leftClick"
      @rightClick="rightClick"
      @middleClick="middleClick"
      @create="createItem"
      @onTabActive="onTabActive"
      tab-name="gitlab"
      :fussysortKeys="['name', 'ssh_url_to_repo', 'description', 'name_with_namespace']"
      single-item="gitlab repo">
      <template slot="controls" slot-scope="prop">
        <i @click="cloneItem(prop.item)" class="fa fa-terminal" title="clone repo to folder" aria-hidden="true"></i>
        <i @click="forkItem(prop.item)" class="fa fa-copy" title="fork repo" aria-hidden="true"></i>
        <i @click="renameItem(prop.item)" class="fa fa-pencil-square-o" aria-hidden="true" title="rename gitlab repo"></i>
        <i @click="deleteItem(prop.item)" class="fa fa-trash" aria-hidden="true" title="delete gitlab repo"></i>
      </template>
    </tab-simple>
    <input
      :nwworkingdir="startDir"
      @change="onRepoClone"
      ref="DirSelecter"
      class="DirSelecter"
      type="file"
      nwdirectory >
  </div>
</template>

<script>
import TabSimple from '@/components/ui/TabBar/TabSimple/TabSimple'

export default {
  components: {
    TabSimple
  },
  data() {
    return {
      items: [],
      startDir: '',
      clonable: null
    }
  },
  computed: {
    isTabActive() {
      return this.$parent.active
    },
  },
  mounted() {
    if (this.isTabActive) {
      this.onTabActive()
    }
    if (process.client) {
      this.startDir = os.homedir()
    }
  },
  methods: {
    async onTabActive() {
      if (!this.items.length) {
        const { data: gitlabRepos } = await this.$axios.get(`/gitlab-repos/get`)
        this.items = gitlabRepos.data
        console.log(gitlabRepos)
      }
    },
    async leftClick(item) {
      const clipboard = nw.Clipboard.get()
      clipboard.set(item.ssh_url_to_repo, 'text')
      await this.$axios.post('/notify', {
        text: item.ssh_url_to_repo,
        title: 'copied to clipboard',
        icon: 'success.png',
      })
      win.close()
    },
    rightClick(item) {
      open(item.web_url)
      win.close()
    },
    middleClick(item) {
      open(item.web_url)
    },
    createItem() {
      this.$prompt(`Create gitlab repo`, '', {
        confirmButtonText: 'OK',
        cancelButtonText: 'Cancel',
        inputPattern: /^[^\\\/\:\*\?\"\<\>\|]+$/,
        inputErrorMessage: 'Invalid gitlab repo name'
      }).then(async (data) => {
        const { data: repo } = await this.$axios.post(`/gitlab-repos/create`, {
          newName: data.value
        })
        this.$message({
          message: `Project ${data.value} created`,
          type: 'success'
        })
        this.items.unshift(repo)
      }).catch(e => {
        console.log(e)
      })
    },
    cloneItem(item) {
      this.clonable = item
      this.$refs.DirSelecter.click()
    },
    onRepoClone() {
      const selectedDir = this.$refs.DirSelecter.value
      const execute = `git clone ${this.clonable.ssh_url_to_repo} && cd ${this.clonable.path} && subl .`
      // @TODO darwin command
      const command = os.platform() !== 'win32'
        ? (os.release().toLowerCase().includes('manjaro')
          ? `/bin/bash -c "xfce4-terminal --tab --drop-down --working-directory='${selectedDir}' -e '${execute}'"`
          : `/bin/bash -c "gnome-terminal --working-directory='${selectedDir}' -e '${execute}'"`)
        : `start cmd.exe @cmd /k "cd /d ${selectedDir} && ${execute}" && exit`
      cmd.run(command)
      win.close()
    },
    forkItem(item) {
      this.$prompt(`Fork gitlab repo`, item.name, {
        confirmButtonText: 'OK',
        cancelButtonText: 'Cancel',
        inputPattern: /^[^\\\/\:\*\?\"\<\>\|\.\s]+$/,
        inputErrorMessage: 'Invalid gitlab repo name'
      }).then(async (data) => {
        const { data: forked } = await this.$axios.post(`/gitlab-repos/fork`, {
          repo: item,
          newName: data.value
        })
        this.$message({
          message: `Project ${data.value} forked from ${item.name}`,
          type: 'success'
        })
        this.items.unshift(forked)
      }).catch(e => {
        console.log(e)
      })
    },
    renameItem(item) {
      this.$prompt(`Rename "${item.name}" gitlabRepo to:`, '', {
        confirmButtonText: 'OK',
        cancelButtonText: 'Cancel',
        inputPattern: /^[^\\\/\:\*\?\"\<\>\|\.\s]+$/,
        inputErrorMessage: 'Invalid gitlabRepo name'
      }).then(async (data) => {
        const newGitlabRepoName = data.value
        if (newGitlabRepoName && newGitlabRepoName !== item.name) {
          await this.$axios.post(`/gitlab-repos/rename`, {
            repo: item,
            newName: data.value
          })
          item.ssh_url_to_repo = item.ssh_url_to_repo.split(item.name).join(newGitlabRepoName)
          item.web_url = item.web_url.split(item.name).join(newGitlabRepoName)
          item.name_with_namespace = item.name_with_namespace.split(item.name).join(newGitlabRepoName)
          item.name = newGitlabRepoName
          item.path = newGitlabRepoName
          const index = _.findIndex(this.items, { id: item.id })
          this.items.splice(index, 1, item)
        }
      }).catch(e => {})
    },
    deleteItem(item) {
      this.$confirm(`Delete gitlab repo ${item.name}. Continue?`, 'Warning', {
        confirmButtonText: 'OK',
        cancelButtonText: 'Cancel',
        type: 'warning'
      }).then(async () => {
        const res = await this.$axios.post(`/gitlab-repos/delete`, {
          repo: item
        })
        const index = _.findIndex(this.items, { id: item.id })
        this.items.splice(index, 1)
      })
    },
  }
}
</script>

<style lang="less" scoped>
@import "./GitlabReposTab.less";
</style>